Index: trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp	(revision 104497)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp	(revision 104622)
@@ -133,8 +133,4 @@
     VKAT_TEST_OPT_COUNT = 900,
     VKAT_TEST_OPT_DEV,
-    VKAT_TEST_OPT_GUEST_ATS_ADDR,
-    VKAT_TEST_OPT_GUEST_ATS_PORT,
-    VKAT_TEST_OPT_HOST_ATS_ADDR,
-    VKAT_TEST_OPT_HOST_ATS_PORT,
     VKAT_TEST_OPT_MODE,
     VKAT_TEST_OPT_NO_AUDIO_OK,
@@ -192,8 +188,4 @@
     { "--exclude",           'e',                               RTGETOPT_REQ_UINT32  },
     { "--exclude-all",       'a',                               RTGETOPT_REQ_NOTHING },
-    { "--guest-ats-addr",    VKAT_TEST_OPT_GUEST_ATS_ADDR,      RTGETOPT_REQ_STRING  },
-    { "--guest-ats-port",    VKAT_TEST_OPT_GUEST_ATS_PORT,      RTGETOPT_REQ_UINT32  },
-    { "--host-ats-address",  VKAT_TEST_OPT_HOST_ATS_ADDR,       RTGETOPT_REQ_STRING  },
-    { "--host-ats-port",     VKAT_TEST_OPT_HOST_ATS_PORT,       RTGETOPT_REQ_UINT32  },
     { "--include",           'i',                               RTGETOPT_REQ_UINT32  },
     { "--outdir",            VKAT_TEST_OPT_OUTDIR,              RTGETOPT_REQ_STRING  },
@@ -729,12 +721,4 @@
         case VKAT_TEST_OPT_TONE_VOL_PERCENT:    return "Test tone volume (percent)\n"
                                                        "    Default: 100";
-        case VKAT_TEST_OPT_GUEST_ATS_ADDR:      return "Address of guest ATS to connect to\n"
-                                                       "    Default: " ATS_TCP_DEF_CONNECT_GUEST_STR;
-        case VKAT_TEST_OPT_GUEST_ATS_PORT:      return "Port of guest ATS to connect to (needs NAT port forwarding)\n"
-                                                       "    Default: 6042"; /* ATS_TCP_DEF_CONNECT_PORT_GUEST */
-        case VKAT_TEST_OPT_HOST_ATS_ADDR:       return "Address of host ATS to connect to\n"
-                                                       "    Default: " ATS_TCP_DEF_CONNECT_HOST_ADDR_STR;
-        case VKAT_TEST_OPT_HOST_ATS_PORT:       return "Port of host ATS to connect to\n"
-                                                       "    Default: 6052"; /* ATS_TCP_DEF_BIND_PORT_VALKIT */
         case VKAT_TEST_OPT_MODE:                return "Test mode to use when running the tests\n"
                                                         "    Available modes:\n"
@@ -790,9 +774,4 @@
     bool        fNoAudioOk     = false;
 
-    const char *pszGuestTcpAddr  = NULL;
-    uint16_t    uGuestTcpPort    = ATS_TCP_DEF_BIND_PORT_GUEST;
-    const char *pszValKitTcpAddr = NULL;
-    uint16_t    uValKitTcpPort   = ATS_TCP_DEF_BIND_PORT_VALKIT;
-
     int           ch;
     RTGETOPTUNION ValueUnion;
@@ -820,20 +799,4 @@
                     return RTMsgErrorExit(RTEXITCODE_SYNTAX, "Invalid test number %u passed to --exclude", ValueUnion.u32);
                 g_aTests[ValueUnion.u32].fExcluded = true;
-                break;
-
-            case VKAT_TEST_OPT_GUEST_ATS_ADDR:
-                pszGuestTcpAddr = ValueUnion.psz;
-                break;
-
-            case VKAT_TEST_OPT_GUEST_ATS_PORT:
-                uGuestTcpPort = ValueUnion.u32;
-                break;
-
-            case VKAT_TEST_OPT_HOST_ATS_ADDR:
-                pszValKitTcpAddr = ValueUnion.psz;
-                break;
-
-            case VKAT_TEST_OPT_HOST_ATS_PORT:
-                uValKitTcpPort = ValueUnion.u32;
                 break;
 
Index: trunk/src/VBox/ValidationKit/utils/audio/vkatCmdGeneric.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkatCmdGeneric.cpp	(revision 104497)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkatCmdGeneric.cpp	(revision 104622)
@@ -206,5 +206,5 @@
      * Do the enumeration.
      */
-    RTEXITCODE rcExit = RTEXITCODE_FAILURE;
+    RTEXITCODE rcExit = RTEXITCODE_SUCCESS;
 
     if (DrvStack.pIHostAudio->pfnGetDevices)
@@ -246,5 +246,5 @@
     audioTestDriverStackDelete(&DrvStack);
 
-    return RTEXITCODE_SUCCESS;
+    return rcExit;
 }
 
@@ -302,5 +302,5 @@
                 uint64_t const cNsElapsed = RTTimeNanoTS() - nsStarted;
                 if (cNsWritten > cNsElapsed + RT_NS_10MS)
-                    RTThreadSleep((cNsWritten - cNsElapsed - RT_NS_10MS / 2) / RT_NS_1MS);
+                    RTThreadSleep(uint32_t(cNsWritten - cNsElapsed - RT_NS_10MS / 2) / RT_NS_1MS);
             }
 
@@ -820,5 +820,5 @@
                     else
                     {
-                        cFramesCaptured = cMaxFrames - cFramesCaptured;
+                        cFramesCaptured = (uint32_t)cMaxFrames - cFramesCaptured;
                         cbCaptured      = PDMAudioPropsFramesToBytes(pMix->pProps, cFramesCaptured);
                     }
Index: trunk/src/VBox/ValidationKit/utils/audio/vkatCommon.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkatCommon.cpp	(revision 104497)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkatCommon.cpp	(revision 104622)
@@ -605,5 +605,5 @@
                 uint64_t const cNsElapsed = nsNow - nsStarted;
                 if (cNsWritten > cNsElapsed + RT_NS_10MS)
-                    RTThreadSleep((cNsWritten - cNsElapsed - RT_NS_10MS / 2) / RT_NS_1MS);
+                    RTThreadSleep(uint32_t(cNsWritten - cNsElapsed - RT_NS_10MS / 2) / RT_NS_1MS);
             }
 
Index: trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp	(revision 104497)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp	(revision 104622)
@@ -1361,5 +1361,5 @@
             else
                 cbToRead = PDMAudioPropsFramesToBytes(&pMix->pStream->Cfg.Props,
-                                                        (uint64_t)cDstFrames * PDMAudioPropsHz(&pMix->pStream->Cfg.Props)
+                                                        cDstFrames * PDMAudioPropsHz(&pMix->pStream->Cfg.Props)
                                                       / PDMAudioPropsHz(&pMix->MixBuf.Props));
             cbToRead = RT_MIN(cbToRead, RT_MIN(cbReadable, cbBuf));