Index: /trunk/src/VBox/ValidationKit/bootsectors/Makefile.kmk
===================================================================
--- /trunk/src/VBox/ValidationKit/bootsectors/Makefile.kmk	(revision 104648)
+++ /trunk/src/VBox/ValidationKit/bootsectors/Makefile.kmk	(revision 104649)
@@ -452,17 +452,9 @@
  bs3-cpu-instr-4_TEMPLATE = VBoxBS3KitImg
  bs3-cpu-instr-4_INCS = . $(bs3-cpu-instr-4_0_OUTDIR)
- bs3-cpu-instr-4_DEFS = BS3_CMN_INSTANTIATE_FILE1=bs3-cpu-instr-4-traphandler.c
- bs3-cpu-instr-4_DEFS += BS3_MODE_INSTANTIATE_FILE1=bs3-cpu-instr-4-traphandler.c
  bs3-cpu-instr-4_SOURCES = \
  	bs3kit/bs3-first-init-all-pe32.asm \
- 	bs3kit/bs3-cmn-instantiate-x0.c16 \
- 	bs3kit/bs3-cmn-instantiate.c32 \
- 	bs3kit/bs3-cmn-instantiate.c64 \
  	bs3-cpu-instr-4.c32 \
  	bs3-cpu-instr-4-asm.asm
  bs3-cpu-instr-4.c32_DEPS = $(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm-auto.h
- bs3-cpu-instr-4_bs3kit/bs3-cmn-instantiate-x0.c16_DEPS = $(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm-auto.h
- bs3-cpu-instr-4_bs3kit/bs3-cmn-instantiate.c32_DEPS = $(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm-auto.h
- bs3-cpu-instr-4_bs3kit/bs3-cmn-instantiate.c64_DEPS = $(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm-auto.h
  bs3-cpu-instr-4_CLEANS = $(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm-auto.h
  
@@ -472,7 +464,4 @@
  
  bs3-cpu-instr-4-template.o:: \
- 		$$(bs3-cpu-instr-4_0_OUTDIR)/bs3kit/bs3-cmn-instantiate-x0.o16 \
- 		$$(bs3-cpu-instr-4_0_OUTDIR)/bs3kit/bs3-cmn-instantiate.o32 \
- 		$$(bs3-cpu-instr-4_0_OUTDIR)/bs3kit/bs3-cmn-instantiate.o64 \
  		$$(bs3-cpu-instr-4_0_OUTDIR)/bs3-cpu-instr-4-asm.o16
 
Index: /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-asm.asm
===================================================================
--- /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-asm.asm	(revision 104648)
+++ /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-asm.asm	(revision 104649)
@@ -1,5 +1,5 @@
 ; $Id$
 ;; @file
-; BS3Kit - bs3-cpu-instr-4
+; BS3Kit - bs3-cpu-instr-4 - SSE, AVX FPU instructions.
 ;
 
Index: /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-template.mac
===================================================================
--- /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-template.mac	(revision 104648)
+++ /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4-template.mac	(revision 104649)
@@ -1,5 +1,5 @@
 ; $Id$
 ;; @file
-; BS3Kit - bs3-cpu-instr-4 - MMX, SSE, AVX FPU instructions, assembly template.
+; BS3Kit - bs3-cpu-instr-4 - SSE, AVX FPU instructions, assembly template.
 ;
 
Index: /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4.c32
===================================================================
--- /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4.c32	(revision 104648)
+++ /trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-4.c32	(revision 104649)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * BS3Kit - bs3-cpu-instr-4 - SSE and AVX FPU instructions, C code template.
+ * BS3Kit - bs3-cpu-instr-4 - SSE, AVX FPU instructions, C code template.
  */
 
@@ -44,18 +44,4 @@
 #include <iprt/asm.h>
 #include <iprt/asm-amd64-x86.h>
-
-
-/*********************************************************************************************************************************
-*   External Symbols                                                                                                             *
-*********************************************************************************************************************************/
-BS3TRAPFRAME volatile       g_Bs3CpuInstr4TrapFrame;
-/** The extended CPU context to save from the trap handler. */
-BS3EXTCTX volatile          g_Bs3CpuInstr4ExtCtxTrap;
-/** Whether the trap handler was called. */
-bool volatile               g_Bs3CpuInstr4TrapRaised;
-
-extern FNBS3TRAPHANDLER16   bs3CpuInstr4TrapHandler_c16;
-extern FNBS3TRAPHANDLER32   bs3CpuInstr4TrapHandler_c32;
-extern FNBS3TRAPHANDLER64   bs3CpuInstr4TrapHandler_c64;
 
 
@@ -828,11 +814,8 @@
      * Prepare globals and execute.
      */
-    g_Bs3CpuInstr4TrapRaised = false;
     g_uBs3TrapEipHint = pCtx->rip.u32;
     if (    bXcptExpect == X86_XCPT_DB
         && !fFpFlagsExpect)
         g_uBs3TrapEipHint += cbInstr + 1;
-    //Bs3MemZero((void *)&g_Bs3CpuInstr4TrapFrame, sizeof(g_Bs3CpuInstr4TrapFrame));
-    //Bs3TrapSetHandlerEx(bFpXcpt, bs3CpuInstr4TrapHandler_c16, bs3CpuInstr4TrapHandler_c32, bs3CpuInstr4TrapHandler_c64);
     Bs3TrapSetJmpAndRestoreWithExtCtxAndRm(pCtx, pExtCtx, pTrapFrame, pExtCtxOut);
 