Index: trunk/src/VBox/Runtime/common/asm/ASMBitFirstClear-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMBitFirstClear-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMBitFirstClear-generic.cpp	(revision 104656)
@@ -45,5 +45,5 @@
 
 
-RTDECL(int32_t) ASMBitFirstClear(const volatile void RT_FAR *pvBitmap, uint32_t cBits) RT_NOTHROW_DEF
+DECLASM(int32_t) ASMBitFirstClear(const volatile void RT_FAR *pvBitmap, uint32_t cBits) RT_NOTHROW_DEF
 {
     const volatile size_t RT_FAR *pu = (const volatile size_t RT_FAR *)pvBitmap;
Index: trunk/src/VBox/Runtime/common/asm/ASMBitFirstSet-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMBitFirstSet-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMBitFirstSet-generic.cpp	(revision 104656)
@@ -45,5 +45,5 @@
 
 
-RTDECL(int32_t) ASMBitFirstSet(const volatile void RT_FAR *pvBitmap, uint32_t cBits) RT_NOTHROW_DEF
+DECLASM(int32_t) ASMBitFirstSet(const volatile void RT_FAR *pvBitmap, uint32_t cBits) RT_NOTHROW_DEF
 {
     const volatile size_t RT_FAR *pu = (const volatile size_t RT_FAR *)pvBitmap;
Index: trunk/src/VBox/Runtime/common/asm/ASMBitNextClear-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMBitNextClear-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMBitNextClear-generic.cpp	(revision 104656)
@@ -45,5 +45,5 @@
 
 
-RTDECL(int) ASMBitNextClear(const volatile void RT_FAR *pvBitmap, uint32_t cBits, uint32_t iBitPrev) RT_NOTHROW_DEF
+DECLASM(int) ASMBitNextClear(const volatile void RT_FAR *pvBitmap, uint32_t cBits, uint32_t iBitPrev) RT_NOTHROW_DEF
 {
     const volatile uint32_t RT_FAR *pau32Bitmap = (const volatile uint32_t RT_FAR *)pvBitmap;
Index: trunk/src/VBox/Runtime/common/asm/ASMBitNextSet-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMBitNextSet-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMBitNextSet-generic.cpp	(revision 104656)
@@ -45,5 +45,5 @@
 
 
-RTDECL(int) ASMBitNextSet(const volatile void RT_FAR *pvBitmap, uint32_t cBits, uint32_t iBitPrev) RT_NOTHROW_DEF
+DECLASM(int) ASMBitNextSet(const volatile void RT_FAR *pvBitmap, uint32_t cBits, uint32_t iBitPrev) RT_NOTHROW_DEF
 {
     const volatile uint32_t RT_FAR *pau32Bitmap = (const volatile uint32_t RT_FAR *)pvBitmap;
Index: trunk/src/VBox/Runtime/common/asm/ASMMemFill32-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMMemFill32-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMMemFill32-generic.cpp	(revision 104656)
@@ -46,5 +46,5 @@
 
 
-RTDECL(void) ASMMemFill32(volatile void RT_FAR *pv, size_t cb, uint32_t u32) RT_NOTHROW_DEF
+DECLASM(void) ASMMemFill32(volatile void RT_FAR *pv, size_t cb, uint32_t u32) RT_NOTHROW_DEF
 {
     Assert(!(cb & 3));
Index: trunk/src/VBox/Runtime/common/asm/ASMMemFirstMismatchingU8-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMMemFirstMismatchingU8-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMMemFirstMismatchingU8-generic.cpp	(revision 104656)
@@ -43,5 +43,5 @@
 
 
-RTDECL(void *) ASMMemFirstMismatchingU8(void const RT_FAR *pv, size_t cb, uint8_t u8) RT_NOTHROW_DEF
+DECLASM(void *) ASMMemFirstMismatchingU8(void const RT_FAR *pv, size_t cb, uint8_t u8) RT_NOTHROW_DEF
 {
     uint8_t const *pb = (uint8_t const RT_FAR *)pv;
Index: trunk/src/VBox/Runtime/common/asm/ASMMemFirstNonZero-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMMemFirstNonZero-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMMemFirstNonZero-generic.cpp	(revision 104656)
@@ -43,5 +43,5 @@
 
 
-RTDECL(void RT_FAR *) ASMMemFirstNonZero(void const RT_FAR *pv, size_t cb) RT_NOTHROW_DEF
+DECLASM(void RT_FAR *) ASMMemFirstNonZero(void const RT_FAR *pv, size_t cb) RT_NOTHROW_DEF
 {
     uint8_t const *pb = (uint8_t const RT_FAR *)pv;
Index: trunk/src/VBox/Runtime/common/asm/ASMMemZero32-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMMemZero32-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMMemZero32-generic.cpp	(revision 104656)
@@ -45,5 +45,5 @@
 
 
-RTDECL(void) ASMMemZero32(volatile void RT_FAR *pv, size_t cb) RT_NOTHROW_DEF
+DECLASM(void) ASMMemZero32(volatile void RT_FAR *pv, size_t cb) RT_NOTHROW_DEF
 {
     memset((void *)pv, 0, cb);
Index: trunk/src/VBox/Runtime/common/asm/ASMMultU64ByU32DivByU32-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMMultU64ByU32DivByU32-generic.cpp	(revision 104626)
+++ trunk/src/VBox/Runtime/common/asm/ASMMultU64ByU32DivByU32-generic.cpp	(revision 104656)
@@ -44,5 +44,5 @@
 
 
-RTDECL(uint64_t) ASMMultU64ByU32DivByU32(uint64_t u64A, uint32_t u32B, uint32_t u32C)
+DECLASM(uint64_t) ASMMultU64ByU32DivByU32(uint64_t u64A, uint32_t u32B, uint32_t u32C)
 {
     RTUINT64U   u;