Index: trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk	(revision 104665)
+++ trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk	(revision 104667)
@@ -109,52 +109,52 @@
  #
  ifdef VBOX_WITH_VBOXDRV
- SYSMODS.win += VBoxNetAdp6
- VBoxNetAdp6_TEMPLATE = VBoxR0Drv
- if defined(VBOX_SIGNING_MODE)
-  VBoxNetAdp6_INSTTYPE.win = none
-  VBoxNetAdp6_DEBUG_INSTTYPE.win = both
- endif
- VBoxNetAdp6_DEFS = IN_RT_R0 IN_SUP_STATIC
- VBoxNetAdp6_INCS := $(PATH_SUB_CURRENT)
- VBoxNetAdp6_SDKS = ReorderCompilerIncs $(VBOX_WINDDK_WLH) $(VBOX_WINPSDK_INCS)
- VBoxNetAdp6_SOURCES = \
- 	win/VBoxNetAdp-win.cpp \
- 	win/VBoxNetAdp-win.rc
- VBoxNetAdp6_DEFS += NDIS_MINIPORT_DRIVER NDIS_WDM=1 BINARY_COMPATIBLE=0
- VBoxNetAdp6_DEFS += NDIS60_MINIPORT=1 NDIS60=1
- VBoxNetAdp6_LDFLAGS.win.x86 = -Entry:DriverEntry@8
- VBoxNetAdp6_LDFLAGS.win.amd64 = -Entry:DriverEntry
- VBoxNetAdp6_LIBS.win = \
- 	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/ntoskrnl.lib \
- 	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/hal.lib \
- 	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/ndis.lib \
- 	$(PATH_STAGE_LIB)/RuntimeR0Drv$(VBOX_SUFF_LIB)
- VBoxNetAdp6_LIBS = \
- 	$(PATH_STAGE_LIB)/SUPR0IdcClient$(VBOX_SUFF_LIB)
-
-
- INSTALLS.win += VBoxNetAdp6-inf
- VBoxNetAdp6-inf_TEMPLATE = VBoxR0DrvInfCat
- VBoxNetAdp6-inf_SOURCES = \
- 	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf
- VBoxNetAdp6-inf_CLEAN = $(VBoxNetAdp6-inf_SOURCES)
- VBoxNetAdp6-inf_BLDDIRS = $(PATH_TARGET)/VBoxNetAdp6Cat.dir
-
- $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf: $(PATH_SUB_CURRENT)/win/VBoxNetAdp6.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
+  SYSMODS.win += VBoxNetAdp6
+  VBoxNetAdp6_TEMPLATE = VBoxR0Drv
+  if defined(VBOX_SIGNING_MODE)
+   VBoxNetAdp6_INSTTYPE.win = none
+   VBoxNetAdp6_DEBUG_INSTTYPE.win = both
+  endif
+  VBoxNetAdp6_DEFS = IN_RT_R0 IN_SUP_STATIC
+  VBoxNetAdp6_INCS := $(PATH_SUB_CURRENT)
+  VBoxNetAdp6_SDKS = ReorderCompilerIncs $(VBOX_WINDDK_WLH) $(VBOX_WINPSDK_INCS)
+  VBoxNetAdp6_SOURCES = \
+  	win/VBoxNetAdp-win.cpp \
+  	win/VBoxNetAdp-win.rc
+  VBoxNetAdp6_DEFS += NDIS_MINIPORT_DRIVER NDIS_WDM=1 BINARY_COMPATIBLE=0
+  VBoxNetAdp6_DEFS += NDIS60_MINIPORT=1 NDIS60=1
+  VBoxNetAdp6_LDFLAGS.win.x86 = -Entry:DriverEntry@8
+  VBoxNetAdp6_LDFLAGS.win.amd64 = -Entry:DriverEntry
+  VBoxNetAdp6_LIBS.win = \
+  	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/ntoskrnl.lib \
+  	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/hal.lib \
+  	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/ndis.lib \
+  	$(PATH_STAGE_LIB)/RuntimeR0Drv$(VBOX_SUFF_LIB)
+  VBoxNetAdp6_LIBS = \
+  	$(PATH_STAGE_LIB)/SUPR0IdcClient$(VBOX_SUFF_LIB)
+
+
+  INSTALLS.win += VBoxNetAdp6-inf
+  VBoxNetAdp6-inf_TEMPLATE = VBoxR0DrvInfCat
+  VBoxNetAdp6-inf_SOURCES = \
+  	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf
+  VBoxNetAdp6-inf_CLEAN = $(VBoxNetAdp6-inf_SOURCES)
+  VBoxNetAdp6-inf_BLDDIRS = $(PATH_TARGET)/VBoxNetAdp6Cat.dir
+
+  $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf: $(PATH_SUB_CURRENT)/win/VBoxNetAdp6.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxNetAdp6-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
 
- ifdef VBOX_SIGNING_MODE
-  VBoxNetAdp6-inf_SOURCES += \
-  	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys \
-  	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat \
-  	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat=>VBoxNetAdp6-PreW10.cat
-
-  $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys: $$(VBoxNetAdp6_1_TARGET) | $$(dir $$@)
+  ifdef VBOX_SIGNING_MODE
+   VBoxNetAdp6-inf_SOURCES += \
+   	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys \
+   	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat \
+   	$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat=>VBoxNetAdp6-PreW10.cat
+
+   $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys: $$(VBoxNetAdp6_1_TARGET) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
-  $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat: \
-  		$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys \
-  		$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf
+   $(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.cat: \
+   		$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.sys \
+   		$(PATH_TARGET)/VBoxNetAdp6Cat.dir/VBoxNetAdp6.inf
 	$(call MSG_TOOL,Inf2Cat,VBoxNetFlt-inf,$@,$<)
 	$(call VBOX_MAKE_CAT_FN, $(@D),$@)
@@ -229,2 +229,3 @@
 include $(FILE_KBUILD_SUB_FOOTER)
 
+a